#include "ArrangementCascade.h"
#include <vector>
#include "Vehicle.h"



ArrangementCascade::ArrangementCascade()
{
}


ArrangementCascade::~ArrangementCascade()
{
}

void ArrangementCascade::startSequence(std::vector<Vehicle*>* in_refVector)
{
	Arrangement::startSequence(in_refVector);
	mIndexCounter = 0;
}

std::vector<Vehicle*>* ArrangementCascade::GetNextSequence()
{
	m_currentArrangement->clear();
	if (mIndexCounter >= m_refVector->size())
	{
		return nullptr;
	}
	else
	{
		//Construct the order
		//Ignore the last one as it is the one that cascades through
		for (unsigned int j = 0; j < m_refVector->size()-1; ++j)
		{
			//Will happen except for case when vehicle is last
			if (j == mIndexCounter)
			{
				m_currentArrangement->push_back(m_refVector->back());
			}
			m_currentArrangement->push_back((*m_refVector)[j]);
		}
		//Special case: for when order is last
		if (mIndexCounter == m_refVector->size()-1)
		{
			m_currentArrangement->push_back(m_refVector->back());
		}
		mIndexCounter++;
	}
	
	return m_currentArrangement;
}
