#include "ElectricCircuit.h"

#include "srcMap/carte.h"
#include "ElectricTerminal.h"

ElectricCircuit::ElectricCircuit(const Carte& inCarte)
{
	for each (auto var in inCarte.GetBorne())
	{
		mMapStation.insert({ var.indexlieu, new ElectricTerminal(var) });
	}
}

ElectricCircuit::ElectricCircuit(const ElectricCircuit & otherEc)
{
	for each (auto var in mMapStation)
	{
		delete var.second;
	}

	this->mMapStation.clear();

	for each (auto var in otherEc.mMapStation)
	{
		mMapStation.insert({ var.first,new ElectricTerminal(*var.second) });
	}
}

ElectricCircuit * ElectricCircuit::clone() const
{
	return new ElectricCircuit(*this);
}

ElectricCircuit::~ElectricCircuit()
{
	for each (auto var in mMapStation)
	{
		delete var.second;
	}
	mMapStation.clear();
}

ElectricTerminal * ElectricCircuit::GetByIndexLieu(int inIndexLieu) const
{
	return mMapStation.at(inIndexLieu);
}

unsigned int ElectricCircuit::computeTotalReservation() const
{
	unsigned int total = 0;
	for each (auto var in mMapStation)
	{
		total += var.second->size();
	}
	return total;
}

ostream & operator<<(ostream & os, const ElectricCircuit & dt)
{
	for each (auto var in dt.mMapStation)
	{
		os << *(var.second) << endl;
	}
	return os;
}
