#include "ObjectiveFunctionSquaredDifference.h"

#include "Vehicle.h"
#include "VehicleSolution.h"
#include "SystemSolution.h"
#include <assert.h>


ObjectiveFunctionSquaredDifference::ObjectiveFunctionSquaredDifference(SystemSolution const* const optimalSolution)
:mOptimalSolution(optimalSolution)
{

}


ObjectiveFunctionSquaredDifference::~ObjectiveFunctionSquaredDifference()
{
}

float ObjectiveFunctionSquaredDifference::ComputeObjectiveFunction(VehicleSolution const * const inVehicleSolution)
{
	float fValue = 0.0f;
	VehicleSolution const * const optSol = mOptimalSolution->mMapVehicleSolution.at(const_cast<Vehicle * const>(inVehicleSolution->mRefVehicle));
	fValue = (inVehicleSolution->mCost - optSol->mCost) * (inVehicleSolution->mCost - optSol->mCost);
	return fValue;
}
