#pragma once

#include <string>
#include <list>
#include <unordered_set>
#include "point.h"
#include "Action.h"
class ElectricTerminal;
class ElectricCircuit;
using namespace std;

class Path
{
public:
	double mMaxAutonomy = 0.0;
	Point mStart;
	Point mEnd;
	float mDistance = 0.0f;
	bool mIsCompleted = false;

	std::list<Action*> mSequenceAction;

	void recomputeDistance();

public:
	Path(Point a, Point b, double autonomie = 160000.0);
	Path(const Path &old_obj);
	Path();
	~Path();

	Path& operator=(const Path& other);

	string toString();
	string toStringInteractive();

	float getDuration() const;
	void removeActionThatStartAfter(float fTimeToKeep);

};
