#include "PerformanceAnalysis.h"
#include <sstream>
#include "Scenario.h"
#include <iomanip>


void PerformanceAnalysis::StartExperiment()
{
	expStart = clock();
}

void PerformanceAnalysis::Reset()
{
	Result newRes;
	result = newRes;
}

void PerformanceAnalysis::StopExperiment(float valueRes)
{
	clock_t endExp = clock();
	double seconds = ((float)(endExp - expStart)) / CLOCKS_PER_SEC;
	Result res;
	res.cost = valueRes;
	res.time = seconds;
	res.nbPause = 0;
	result = res;
}

void PerformanceAnalysis::PauseExperiment(float valueRes)
{
	if (result.nbPause == 0)
	{
		StopExperiment(valueRes);
		result.nbPause = 1;
	}
	else
	{
		clock_t endExp = clock();
		double seconds = ((float)(endExp - expStart)) / CLOCKS_PER_SEC;
		result.cost = valueRes;
		result.time += seconds;
		result.nbPause++;
	}

}

std::string PerformanceAnalysis::toString() const
{
	std::ostringstream ss;
	string strTime = to_string(result.time) + "s";
	ss << std::setw(20) << left << result.cost  << std::setw(20) << left << strTime << std::setw(20) << left << result.nbPause;
	return ss.str();
}

std::string PerformanceAnalysis::toStringHeader()
{
	std::ostringstream ss;
	ss << std::setw(20) << left << "Cost" << std::setw(20) << left << "Exec time" << std::setw(20) << left << "Nb computation spread";
	return ss.str();
}

PerformanceAnalysis::PerformanceAnalysis()
{
}


PerformanceAnalysis::~PerformanceAnalysis()
{
}

std::ostream & operator<<(std::ostream & os, const PerformanceAnalysis & dt)
{
	os << dt.toString();
	return os;
}
