#pragma once

#include <string>
#include <vector>
#include "IScenario.h"
class Vehicle;
class Carte;
class ElectricCircuit;
class IScenarioLoader;

using namespace std;

class ScenarioData;
class IVehicleSolver;
class IObjectiveFunction;
class ISystemSolver;

class Scenario : public IScenario
{
protected:
	ScenarioData* mLoaderData;


public:
	enum SolverType
	{
		//Basic
		eINIT = 0,
		eNO_COOP,
		eNO_COOP_WAIT,
		//Ordered
		eHCA_FI,
		eHCA_CASCADE,
		eHCA_PERMUTATION,
		eWHCA_SMALL_FI,
		eWHCA_MEDIUM_FI,
		eWHCA_LARGE_FI,
		eWHCA_SMALL_CASCADE,
		eWHCA_MEDIUM_CASCADE,
		eWHCA_LARGE_CASCADE,
		eWHCA_SMALL_PERMUTATION,
		eWHCA_MEDIUM_PERMUTATION,
		eWHCA_LARGE_PERMUTATION,

		eMAX_SOLVERTYPE
	};

	enum TArrangement {
		eNONE = 0,
		eCASCADE,
		ePERMUTATION,

		eMAX_ARRANGEMENT
	};

	static const string sSolverTypeAssociation[eMAX_SOLVERTYPE];
	static const string sArrangementAssociation[eMAX_ARRANGEMENT];

	Scenario(IScenarioLoader* inScenarioLoader,Carte const & inRefCarte);
	~Scenario();

	virtual ScenarioData* GetRefData() const { return mLoaderData; }
	std::string toStringPerformance() const;

};

