#pragma once

#include <map>
#include <ostream>
#include <string>
#include<vector> 
class Vehicle;
class VehicleSolution;

using namespace std;

class SystemSolution
{
protected:
	std::vector<VehicleSolution*> mOrderedVehicleSolution;

public:
	std::map<Vehicle*, VehicleSolution*> mMapVehicleSolution;
	float mSystemObjectiveFunctionValue = INFINITY;
	string mDescription = " No description given";

	SystemSolution();
	~SystemSolution();
	SystemSolution& operator=(const SystemSolution& other);
	SystemSolution* clone() const;

	void AddSolution(VehicleSolution* newSolution);
	VehicleSolution* GetLastVehicleSolution() const { return mOrderedVehicleSolution.back(); }
	bool IsImpossible() const;

	friend ostream& operator<<(ostream& os, const SystemSolution& dt);

};

ostream& operator<<(ostream& os, const SystemSolution& dt);

