#pragma once

#include <string>

class Path;
class Vehicle;
class ElectricCircuit;
using namespace std;

class VehicleSolution
{
public:

	Vehicle * mRefVehicle = nullptr;
	Path* mPath = nullptr;
	float mCost = INFINITY;

	const string cst_no_path = "Impossible!";

	VehicleSolution(Vehicle* inRefVehicle);
	VehicleSolution(const VehicleSolution &old_obj);
	~VehicleSolution();
	VehicleSolution& operator=(const VehicleSolution& other);
	VehicleSolution * clone() const;

	string ComputeTimeRoundedSecondInteractive() const;
	void CommitReservation(float fIgnoreAfterTime = INFINITY);
	void RevertReservation(float fIgnoreBeforeTime = -INFINITY);
	bool keepPartialSolution(float fLimitTime);
	string toString() const;
	string toStringInteractive() const;
	bool isValid() const;
	bool IsImpossible() const;
	size_t actionCount() const;
	
	friend ostream& operator<<(ostream& os, const VehicleSolution& dt);
};



ostream& operator<<(ostream& os, const VehicleSolution& dt);

