#pragma once
#include "IVehicleSolver.h"
#include <math.h>

class Carte;
class ElectricCircuit;
class IObjectiveFunction;

class VehicleSolverIgnoreStationOptimal :
	public IVehicleSolver
{
private:

	Carte const *const mRefCarte = nullptr;
	IObjectiveFunction *const mRefObjectiveFunction = nullptr;

	float mfTimeHorizon = INFINITY;

public:
	VehicleSolverIgnoreStationOptimal(Carte const *const inCarte,ElectricCircuit * inRefElectricCircuit, IObjectiveFunction* inObjectiveFunction);
	virtual ~VehicleSolverIgnoreStationOptimal();

	void SetTimeHorizon(float fTimeHorizon) { mfTimeHorizon = fTimeHorizon; }

	virtual void SolveFor(Vehicle* inVehicleToSolve, VehicleSolution* out_RefSolution);
};

