#include "VehicleSolverWait.h"

#include <queue>
#include <unordered_set>
#include "srcMap/carte.h"
#include "VehicleSolution.h"
#include "ElectricCircuit.h"
#include "RequestCarte.h"
#include "Path.h"
#include "ActionWait.h"
#include "IObjectiveFunction.h"

VehicleSolverWait::VehicleSolverWait(Carte const *const inCarte, IObjectiveFunction* inObjectiveFunction, ElectricCircuit* inElectricCircuit)
	:IVehicleSolver(inObjectiveFunction, inElectricCircuit)
	, mRefCarte(inCarte)
	, mRefObjectiveFunction(inObjectiveFunction)
{
}


VehicleSolverWait::~VehicleSolverWait()
{
}

void VehicleSolverWait::SolveFor(Vehicle * inVehicleToSolve, VehicleSolution * out_RefSolution)
{
	RequestCarte request;
	request.mRefElectricCircuit = mRefElectricCircuit;
	request.mRefVehicleRequested = inVehicleToSolve;
	//cout << *mRefElectricCircuit << endl;
	mRefCarte->calculerTrajet((*out_RefSolution->mPath), request);
	out_RefSolution->mCost = mRefObjectiveFunction->ComputeObjectiveFunction(out_RefSolution);
	out_RefSolution->CommitReservation();
}
